package l15_collections;

import java.util.HashSet;
import java.util.LinkedHashSet;
import java.util.Set;
import java.util.TreeSet;

public class CustomSetTestShorter {

	record MyType(int n, String string) implements Comparable<MyType> {

		@Override
		public String toString() {
			return STR."\{n}: \{string}";
		}

		@Override
		public int compareTo(MyType mt) {
			return this.n - mt.n;
		}
	}

	private static final int[] intArray = { 3, 5, 2, 6, 9, 2, 7, 8 };

	private static final String[] stringArray = "three five two six nine two seven eight".split(" ");

	private static void fill(Set<MyType> set) {
		for(int i = 0; i < intArray.length; i++)
			set.add(new MyType(intArray[i], stringArray[i]));
	}

	private static void test(Set<MyType> set) {
		fill(set);
		System.out.println(set.getClass().getName());
		System.out.println(set);
		System.out.println();
	}

	public static void main(String[] args) {
		test(new HashSet<>());
		test(new TreeSet<>());
		test(new LinkedHashSet<>());
	}
}

