package l15_collections;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;

public class IteratorDemo {

	public static void main(String[] args) {
		List<String> arrayList = new ArrayList<>(Arrays.asList("A S D F G H J".split(" ")));

		// Use iterator to display contents of arrayList
		System.out.print("Original contents of arrayList: ");
		Iterator<String> iterator = arrayList.iterator();
		while(iterator.hasNext()) {
			System.out.print(STR."\{iterator.next()} ");
		}
		System.out.println();

		// Modify objects being iterated - listIterator
		ListIterator<String> listIterator = arrayList.listIterator();
		while(listIterator.hasNext()) {
			listIterator.set(STR."\{listIterator.next()}+");
		}
		System.out.print("Modified contents of arrayList: ");
		iterator = arrayList.iterator();
		while(iterator.hasNext()) {
			System.out.print(STR."\{iterator.next()} ");
		}
		System.out.println();

		// Now, display the list backwards
		System.out.print("Modified list backwards: ");
		while(listIterator.hasPrevious()) {
			System.out.print(STR."\{listIterator.previous()} ");
			// Removes from the list the last element that was returned by next() or previous()
			listIterator.remove();
		}
		System.out.println();
		System.out.println(STR."arrayList.size() = \{arrayList.size()}");
	}
}

