package l15_collections;

import java.util.*;

public class ListDemo {
	public static void main(String [] args) {
	
//	Create the list
		List<String> list = new LinkedList<>();	//	Doubly-linked list
//		List<String> list = new ArrayList<>();	//	List implemented as growable array

//	Append an element to the list
		list.add("a");
		list.add("b");

//	Insert an element at the head of the list
		list.addFirst("b");
		list.addFirst("d");
		list.add("e");
		System.out.println(list);

//	Retrieving the element at the end of the list
		System.out.println(STR."list.getLast(): \{list.getLast()}");
//	Retrieving the element at the head of the list
		System.out.println(STR."list.getFirst(): \{list.getFirst()}");

//	Removes the first occurrence of the specified element from this list, if it
//	is present. If this list does not contain the element, it is unchanged.
//	Returns true if this list contained the specified element

		System.out.println(STR."list.removeFirst(): \{list.removeFirst()}"); // remove the first element
		while(list.remove("b"));	//	remove all b's
		System.out.print("remove all b's: ");
		System.out.println(list);
		System.out.println();

//	Create a list
		list = Arrays.asList("Just a sample list of Strings".split(" "));
		System.out.println(list.getClass().getName());
		System.out.print("Original list: ");
		System.out.println(list);

//	Sort
//	Collections.sort(list);
		list.sort(String::compareTo);
		System.out.print("Collections.sort(list): ");
		System.out.println(list);

//	Case-insensitive sort
		list.sort(String.CASE_INSENSITIVE_ORDER);
		System.out.print("list.sort(String.CASE_INSENSITIVE_ORDER: ");
		System.out.println(list);

//	Reverse-order sort
		list.sort(Collections.reverseOrder());
		System.out.print("list.sort(Collections.reverseOrder()): ");
		System.out.println(list);

//	Case-insensitive reverse-order sort
		list.sort(Collections.reverseOrder(String.CASE_INSENSITIVE_ORDER));
		System.out.print("list.sort(Collections.reverseOrder(String.CASE_INSENSITIVE_ORDER)): ");
		System.out.println(list);
	}
}

