package l15_collections;

import java.util.*;

public class MapTest {

	public static void test(Map<String, Integer> map) {
		System.out.println(map.getClass().getName());
		String[] keys = { "two", "three", "one", "four" };
		Integer[] values = { 2, 3, 1, 4 };
		for (int i = 0; i < keys.length; ++i) {
			map.put(keys[i], values[i]);
		}
		System.out.println(STR."Size = \{map.size()}");
		System.out.println(STR."Keys: \{map.keySet()}");
		System.out.println(STR."Values: \{map.values()}");
		System.out.println(map);
		map.put(keys[1], values[1]);
		System.out.println(map);
		System.out.println();
	}

	public static void main(String[] args) {
		//	HashMap: Implementation based on a hash table.
		//	Provides constant-time performance for inserting and locating pairs.
		test(new HashMap<>());

		//	TreeMap: When you view the keys or the pairs, they will be in
		//	sorted order (determined by Comparable or Comparator)
		test(new TreeMap<>());

		//	LinkedHashMap: Like a HashMap, but when you iterate through it,
		//	you get the pairs in insertion/last access order
		test(new LinkedHashMap<>());
		test(new LinkedHashMap<>(9, .5f, true));
	}
}

