package l15_collections;

import java.util.HashSet;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

//	HashSet
//	For Sets where fast lookup time is important. Objects must also define
//	hashCode(). It makes no guarantees as to the iteration order of the set; in
//	particular, it does not guarantee that the order will remain constant over
//	time.

//	TreeSet
//	An ordered Set backed by a tree. This way, you can extract an ordered sequence
//	from a Set.

//	LinkedHashSet
//	Has the lookup speed of a HashSet, but maintains the order in which you add the
//	elements (the insertion order), internally using a linked list. Thus, when you
//	iterate through the Set, the results appear in insertion order.

public class SetTest {

	private static void fill(Set<String> set) {
		set.addAll(List.of("one Two three Four five Six seven".split(" ")));
	}

	private static void printSet(Set<String> set) {
		System.out.println();
		System.out.println(set.getClass().getName());
		System.out.println(set);
		System.out.println(STR."set.contains(\"one\"): \{set.contains("one")}");
	}

	private static void test(Set<String> set) {
		fill(set);
		fill(set);
		printSet(set);
	}

	public static void main(String[] args) {
		test(new HashSet<>());
		test(new TreeSet<>());
		test(new LinkedHashSet<>());
	}
}

