package l15_collections;

import utilities.RandomGenerators;
import java.util.Map;
import java.util.TreeMap;
import java.util.concurrent.atomic.AtomicInteger;

public class Statistics {

	private static void printMap(Map<Integer, AtomicInteger> map) {
		map.forEach((n, counter) -> System.out.format("%3d: %6s%n", n, counter));
	}

	public static void main(String[] args) {

		Map<Integer, AtomicInteger> map = new TreeMap<>();
		// Returns:
		// the current (existing or computed) value associated with the specified key
		for(int i = 0; i < 100000; i++) {
			map.computeIfAbsent(RandomGenerators.getInt(10), counter -> new AtomicInteger())
				.incrementAndGet();
		}
		printMap(map);
	}
}
