package l15_collections;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.atomic.AtomicInteger;

public class SynchronizedSetExample {
	private static final AtomicInteger atomicInteger = new AtomicInteger();

	public static void main(String... args) {
		Set<Integer> set = new HashSet<>();
//		Set<Integer> set = Collections.synchronizedSet(new HashSet<>());

		try(ExecutorService e = Executors.newFixedThreadPool(8)) {
			for (int i = 0; i < 10000; i++) {
				e.submit(() -> set.add(atomicInteger.incrementAndGet()));
			}
		}
		System.out.println(STR."Final set size is \{set.size()}");
	}
}
