package l15_collections;

import java.util.List;
import java.util.PriorityQueue;

public class ToDoList {

	// Record definitions nested in other classes/records are implicitly static
	public record ToDoItem(String toDo, char primary, int secondary) implements Comparable<ToDoItem> {

		@Override
		public int compareTo(ToDoItem item) {
			if (primary != item.primary) return primary - item.primary;
			return secondary - item.secondary;
		}

		@Override
		public String toString() {
			return STR."\{String.valueOf(primary)}\{secondary}: \{toDo}";
		}
	}

	public static void main(String[] args) {
		PriorityQueue<ToDoItem> toDoList = new PriorityQueue<>(List.of(
			new ToDoItem("Empty trash", 'C', 4),
			new ToDoItem("Feed dog", 'A', 2),
			new ToDoItem("Feed bird", 'B', 7),
			new ToDoItem("Mow lawn", 'C', 3),
			new ToDoItem("Water lawn", 'A', 1),
			new ToDoItem("Feed cat", 'B', 1)
		));

		while(!toDoList.isEmpty()) {
			System.out.println(toDoList.poll());
		}
	}
}

